﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DxLibDLL;

namespace Ryujin
{
    // キー入力を管理するためのクラスです。
    class KeyManager
    {
        // マネジャー。
        private static KeyManager manager = new KeyManager();

        // キー状態。
        private int[] stateKey = new int[256];

        // プライベートなコンストラクタ。
        private KeyManager()
        {
            ; // 何もしない
        }
        
        // マネジャーを返します。
        public static KeyManager GetInstance()
        {
            return manager;
        }

        // キー状態を取得します。
        public int GetHitKeyStateAll_2()
        {
            byte[] GetHitKeyStateAll_Key = new byte[256];
            DX.GetHitKeyStateAll(out GetHitKeyStateAll_Key[0]);
            for (int i = 0; i < GetHitKeyStateAll_Key.Length; i++)
            {
                if (GetHitKeyStateAll_Key[i] == 1)
                    this.stateKey[i] ++;
                else
                    this.stateKey[i] = 0;
            }

            return 0;
        }

        // 受け取ったキー番号の現在の入力状態を返す
        public int CheckStateKey(int Handle)
        {
            return this.stateKey[Handle];
        }
    }
}
