﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DxLibDLL;

namespace Ryujin
{
    // メインルーチンクラスです。
    class Program
    {
        // キャラクタ画像 9枚分。X2(変身用)
        public static int[,] img_ch = new int[2,12];

        // キャラクターデータ
        public static Ch ch = new Ch();

        // ループ処理。
        private static int ProcessLoop()
        {
            if (DX.ProcessMessage() != 0)
                return -1; // プロセス処理がエラーなら -1を返す
            if (DX.ClearDrawScreen() != 0)
                return -1; // 画面クリア処理がエラーなら -1を返す

            KeyManager keyManager = KeyManager.GetInstance();
            keyManager.GetHitKeyStateAll_2(); //現在のキー入力処理を行う

            return 0;
        }

        // メインメソッド。
        public static void Main(string[] args)
        {
            DX.ChangeWindowMode(1); // ウインドウモード

            // 初期化と裏画面化
            if (DX.DxLib_Init() == -1 || DX.SetDrawScreen(DX.DX_SCREEN_BACK) != 0)
                return;

            while (ProcessLoop() == 0)
            {
                switch (Global.func_state)
                {
                    case 0:
                        // データロード
                        LoadManager loadManager = LoadManager.GetInstance();
                        loadManager.load();
                        Global.func_state = 100;
                        break;
                    case 100:
                        GraphManager graphManager = GraphManager.GetInstance();
                        graphManager.graph_main(); // 描画メイン
                        break;
                    default:
                        return;
                }
                
                KeyManager keyManager = KeyManager.GetInstance();
                if (keyManager.CheckStateKey(DX.KEY_INPUT_ESCAPE) == 1)
                    break; //エスケープが入力されたらブレイク

                DX.ScreenFlip(); // 裏画面反映
            }

            DX.DxLib_End(); // DXライブラリ終了処理
        }
    }
}
