﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DxLibDLL;

namespace Ryujin
{
    /// <summary>
    /// キー入力を管理するためのクラスです。
    /// </summary>
    class KeyManager
    {
        /// <summary>
        /// マネジャー。
        /// </summary>
        private static KeyManager manager = new KeyManager();

        /// <summary>
        /// キー状態。
        /// </summary>
        private int[] stateKey = new int[256];

        /// <summary>
        /// プライベートなコンストラクタ。
        /// </summary>
        private KeyManager()
        {
            ; // 何もしない
        }
        
        /// <summary>
        /// マネジャーを返します。
        /// </summary>
        /// <returns>マネジャー</returns>
        public static KeyManager GetInstance()
        {
            return manager;
        }

        /// <summary>
        /// キー状態を取得します。
        /// </summary>
        /// <returns>常に 0</returns>
        public int GetHitKeyStateAll_2()
        {
            byte[] GetHitKeyStateAll_Key = new byte[256];
            DX.GetHitKeyStateAll(out GetHitKeyStateAll_Key[0]);
            for (int i = 0; i < GetHitKeyStateAll_Key.Length; i++)
            {
                if (GetHitKeyStateAll_Key[i] == 1)
                    this.stateKey[i] ++;
                else
                    this.stateKey[i] = 0;
            }

            return 0;
        }

        /// <summary>
        /// 受け取ったキー番号の現在の入力状態を返します。
        /// </summary>
        /// <param name="Handle">キー番号</param>
        /// <returns>現在の入力状態</returns>
        public int CheckStateKey(int Handle)
        {
            return this.stateKey[Handle];
        }
    }
}
