﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DxLibDLL;

namespace Ryujin
{
    /// <summary>
    /// 画像の読み込みを管理するクラスです。
    /// </summary>
    class LoadManager
    {
        /// <summary>
        /// マネジャー。
        /// </summary>
        private static LoadManager manager = new LoadManager();

        /// <summary>
        /// プライベートなコンストラクタ。
        /// </summary>
        private LoadManager()
        {
            ; // 何もしない
        }
        
        /// <summary>
        /// マネジャーを返します。
        /// </summary>
        /// <returns>マネジャー</returns>
        public static LoadManager GetInstance()
        {
            return manager;
        }

        /// <summary>
        /// 画像を読み込みます。
        /// </summary>
        public void load()
        {
            GV.img_board[10] = DX.LoadGraph("../../dat/img/board/10.png");
            GV.img_board[11] = DX.LoadGraph("../../dat/img/board/11.png");
            GV.img_board[12] = DX.LoadGraph("../../dat/img/board/12.png");
            GV.img_board[20] = DX.LoadGraph("../../dat/img/board/20.png");
            DX.LoadDivGraph("../../dat/img/char/0.png", 12, 4, 3, 73, 73, out GV.img_ch[0, 0]);
        }
    }
}
