﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DxLibDLL;

namespace Ryujin
{
    /// <summary>
    /// グラフィックスを管理するクラスです。
    /// </summary>
    class GraphManager
    {
        /// <summary>
        /// マネジャー
        /// </summary>
        private static GraphManager manager = new GraphManager();

        /// <summary>
        /// プライベートなコンストラクタ。
        /// </summary>
        private GraphManager()
        {
            ; // 何もしない
        }
        
        /// <summary>
        /// マネジャーを返します。
        /// </summary>
        /// <returns>マネジャー</returns>
        public static GraphManager GetInstance()
        {
            return manager;
        }

        /// <summary>
        /// 自キャラクタを描画します。
        /// </summary>
        private void graph_ch()
        {
            DX.DrawRotaGraphF((float)GV.ch.x + Setting.FIELD_X, (float)GV.ch.y + Setting.FIELD_Y, 1.0, 0.0, GV.img_ch[0, GV.ch.img], 1);
        }

        /// <summary>
        /// ボードを描画します。
        /// </summary>
        private void graph_board()
        {
            DX.DrawGraph(0, 0, GV.img_board[10], 0);
            DX.DrawGraph(0, 16, GV.img_board[11], 0);
            DX.DrawGraph(0, 464, GV.img_board[12], 0);
            DX.DrawGraph(416, 0, GV.img_board[20], 0);
        }

        /// <summary>
        /// 描画します。
        /// </summary>
        public void graph_main()
        {
            this.graph_ch();
            this.graph_board();
        }
    }
}
