﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ryujin
{
    /// <summary>
    /// 自キャラクタを表すクラスです。
    /// </summary>
    class Ch
    {
        /// <summary>
        ///  フラグ。
        /// </summary>
        public int flag;

        /// <summary>
        /// カウンタ。
        /// </summary>
        public int cnt;

        /// <summary>
        /// パワー。
        /// </summary>
        public int power;

        /// <summary>
        /// ポイント。
        /// </summary>
        public int point;

        /// <summary>
        /// スコア。
        /// </summary>
        public int score;

        /// <summary>
        /// 残機数。
        /// </summary>
        public int num;

        /// <summary>
        /// 無敵状態とカウント。
        /// </summary>
        public int mutekicnt;

        /// <summary>
        /// ショットモード。
        /// </summary>
        public int shot_mode;

        /// <summary>
        /// お金。
        /// </summary>
        public int money;

        /// <summary>
        /// 画像。
        /// </summary>
        public int img;

        /// <summary>
        /// スローかどうか。
        /// </summary>
        public int slow;

        /// <summary>
        /// X座標。
        /// </summary>
        public double x;

        /// <summary>
        /// Y座標。
        /// </summary>
        public double y;

        /// <summary>
        /// 最初の初期化をします。
        /// </summary>
        public void first_ini()
        {
            this.x = Setting.FIELD_MAX_X / 2;
            this.y = Setting.FIELD_MAX_Y * 3 / 4;
        }

        /// <summary>
        /// キャラクタ画像をループします。
        /// </summary>
        public void calc_ch()
        {
            this.cnt++;
            this.img = (this.cnt % 24) / 6;
        }

        /// <summary>
        /// キャラクタの移動制御をします。
        /// </summary>
        public void ch_move()
        {
            int sayu_flag = 0;
            int joge_flag = 0;
            double x;
            double y;
            double mx;
            double my;
            double naname = 1.0;
            double[] move_x = { -4.0, 4.0, 0.0, 0.0 }; // 左右のスピード
            double[] move_y = { 0.0, 0.0, 4.0, -4.0 }; // 上下のスピード
            int[] inputpad = new int[4];

            KeyManager keyManager = KeyManager.GetInstance();
            inputpad[0] = keyManager.ChckStatePad(GV.configpad.left);
            inputpad[1] = keyManager.ChckStatePad(GV.configpad.right);
            inputpad[2] = keyManager.ChckStatePad(GV.configpad.down);
            inputpad[3] = keyManager.ChckStatePad(GV.configpad.up);

            if (keyManager.ChckStatePad(GV.configpad.left) > 0) // 左キーが押されていたら
                this.img += 4 * 2; // 画像を左向きに
            else if (keyManager.ChckStatePad(GV.configpad.right) > 0) // 右キーが押されていたら
                this.img += 4 * 1; // 画像を右向きに

            for (int i = 0; i < 2; i++) // 左右分
                if (inputpad[i] > 0) // 左右どちらかの入力があれば
                    sayu_flag = 1; // 左右入力フラグを立てる
            for (int i = 2; i < 4; i++) // 上下分
                if (inputpad[i] > 0) // 上下どちらかの入力があれば
                    joge_flag = 1; // 上下フラグを立てる

            if (sayu_flag == 1 && joge_flag == 1) // 左右、上下両方の入力があれば斜めだということ
                naname = Math.Sqrt(2.0); // 移動スピードを 1/ルート2に

            for (int i = 0; i < inputpad.Length; i++)
            {
                if (inputpad[i] > 0)// i方向のキーボード、パッドどちらかの入力があれば
                {
                    // 今の X座標をとりあえず x,yに格納
                    x = this.x;
                    y = this.y;

                    // 移動分を mx, myに代入
                    mx = move_x[i]; 
                    my = move_y[i];
                    if (keyManager.ChckStatePad(GV.configpad.slow) > 0) // 低速移動なら
                    {
                        // 移動スピードを 1/3に
                        mx = move_x[i] / 3.0;
                        my = move_y[i] / 3.0;
                    }

                    // 今の座標と移動分を足す
                    x += mx / naname;
                    y += my / naname;

                    if (! (x < 10 || x > Setting.FIELD_MAX_X - 10 || y < 5 || y > Setting.FIELD_MAX_Y - 5)) // 計算結果が移動範囲内なら
                    {
                        // 実際に移動させる
                        this.x = x;
                        this.y = y;
                    }
                }
            }
        }
    }
}
