﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ryujin
{
    /// <summary>
    /// グローバル変数や関数を管理するためのクラスです。
    /// </summary>
    class GV
    {
        /// <summary>
        /// 自キャラクタ。
        /// </summary>
        public static Ch ch = new Ch();

        /// <summary>
        /// 敵キャラクタ群。
        /// </summary>
        public static EnemyGroup enemys = new EnemyGroup();

        /// <summary>
        /// 敵の出現情報群。
        /// </summary>
        public static EnemyOrderGroup enemy_orders = new EnemyOrderGroup();
        
        /// <summary>
        /// 敵の弾幕群。
        /// </summary>
        public static ShotGroup shots = new ShotGroup();

        /// <summary>
        /// メインメソッド状態。
        /// </summary>
        public static int func_state;
        
        /// <summary>
        /// コンフィグ。
        /// </summary>
        public static ConfigPad configpad = new ConfigPad();

        /// <summary>
        /// ゲーム中のカウンタ。
        /// </summary>
        public static int stage_count;

        /// <summary>
        /// プライベートなコンストラクタ。
        /// </summary>
        private GV()
        {
            ;  //何もしない
        }

        /// <summary>
        /// 最初の初期化処理をします。
        /// </summary>
        public static void first_ini()
        {
            configpad.first_ini(); // コンフィグの初期化
        }

        /// <summary>
        /// ゲームの初期化をします。
        /// </summary>
        public static void ini()
        {
            stage_count = 1;
            ch.ini(); // 自キャラクタの初期化
        }
    }
}
