﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ryujin
{
    /// <summary>
    /// 弾を表すクラスです。
    /// </summary>
    class Bullet
    {
        /// <summary>
        /// フラグ。
        /// </summary>
        public int flag;

        /// <summary>
        /// 種類。
        /// </summary>
        public int knd;

        /// <summary>
        /// カウンタ。
        /// </summary>
        public int cnt;

        /// <summary>
        /// 色。
        /// </summary>
        public int col;

        /// <summary>
        /// 状態。
        /// </summary>
        public int state;

        /// <summary>
        /// 少なくとも消さない時間。
        /// </summary>
        public int till;

        /// <summary>
        /// エフェクトの種類。
        /// </summary>
        public int eff;

        /// <summary>
        /// X座標。
        /// </summary>
        public double x;

        /// <summary>
        /// Y座標。
        /// </summary>
        public double y;

        /// <summary>
        /// 角度。
        /// </summary>
        public double angle;

        /// <summary>
        /// スピード。
        /// </summary>
        public double spd;

        /// <summary>
        /// ベースの角度。
        /// </summary>
        public double[] base_angle = new double[1];

        /// <summary>
        /// 一次記憶スピード。
        /// </summary>
        public double[] rem_spd = new double[1];

        /// <summary>
        /// 初期化します。
        /// </summary>
        public void initialize()
        {
            this.flag = 0;
            this.knd = 0;
            this.cnt = 0;
            this.col = 0;
            this.state = 0;
            this.till = 0;
            this.eff = 0;
            this.x = 0.0;
            this.y = 0.0;
            this.angle = 0.0;
            this.spd = 0.0;
            for (int i = 0; i < this.base_angle.Length; i++)
                this.base_angle[i] = 0.0;
            for (int i = 0; i < this.rem_spd.Length; i++)
                this.rem_spd[i] = 0.0;
        }

        /// <summary>
        /// 計算します。
        /// </summary>
        public void calc()
        {
            this.x += Math.Cos(this.angle) * this.spd;
            this.y += Math.Sin(this.angle) * this.spd;
            this.cnt++;

            if (this.x < -50 || Setting.FIELD_MAX_X + 50 < this.x || this.y < -50 || Setting.FIELD_MAX_Y + 50 < this.y) // 画面から外れたら
                if (this.till < this.cnt) // 最低消えない時間より長ければ
                    this.flag = 0; // 消す
        }
    }
}
