﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ryujin
{
    /// <summary>
    /// 設定を格納するクラスです。
    /// </summary>
    class Setting
    {
        /// <summary>
        /// ベースディレクトリ。
        /// </summary>
        public const string BASE_DIR = "../../dat/";

        /// <summary>
        /// フィールド X座標最大値。
        /// </summary>
        public const int FIELD_MAX_X = 384;

        /// <summary>
        /// フィールド Y座標最大値。
        /// </summary>
        public const int FIELD_MAX_Y = 448;

        /// <summary>
        /// フィールド X座標最小値。
        /// </summary>
        public const int FIELD_X = 32;

        /// <summary>
        /// フィールド Y座標最小値。
        /// </summary>
        public const int FIELD_Y = 16;
        
        /// <summary>
        /// パッドキーの最大数。
        /// </summary>
        public const int PAD_MAX = 16;

        /// <summary>
        /// 敵の同時表示最大数。
        /// </summary>
        public const int ENEMY_MAX = 30;

        /// <summary>
        /// 敵の出現情報の最大数。
        /// </summary>
        public const int ENEMY_ORDER_MAX = 500;

        /// <summary>
        /// 弾幕が持つ弾の最大数。
        /// </summary>
        public const int SHOT_BULLET_MAX = 1000;

        /// <summary>
        /// 一度に画面に表示できる敵の弾幕の最大数。
        /// </summary>
        public const int SHOT_MAX = 30;

        /// <summary>
        /// 自キャラクタのショットの登録最大数。
        /// </summary>
        public const int CSHOT_MAX = 200;

        /// <summary>
        /// 効果音の種類の最大数。
        /// </summary>
        public const int SE_MAX = 100;

        /// <summary>
        /// エフェクトの登録最大数。
        /// </summary>
        public const int EFFECT_MAX = 100;

        /// <summary>
        /// 消滅エフェクトの登録最大数。
        /// </summary>
        public const int DEL_EFFECT_MAX = 30;

        /// <summary>
        /// 自キャラクタの大きさ(半径)。
        /// </summary>
        public const double CRANGE = 2.0;

        /// <summary>
        /// ボスの定位置 X座標。
        /// </summary>
        public const double BOSS_POS_X = FIELD_MAX_X / 2;

        /// <summary>
        /// ボスの定位置 Y座標。
        /// </summary>
        public const double BOSS_POS_Y = 100.0;

        /// <summary>
        /// ボスが持つ弾の最大数。
        /// </summary>
        public const int BOSS_BULLET_MAX = 3000;
        
        /// <summary>
        /// 弾幕最大数。
        /// </summary>
        public const int DANMAKU_MAX = 50;

        /// <summary>
        /// 不明。原作では boss_shot.cppで宣言しているが、暫定的にここに記述する。
        /// </summary>
        public const double V0 = 10.0;

        /// <summary>
        /// プライベートなコンストラクタ。
        /// </summary>
        private Setting()
        {
            ; // 何もしない
        }
    }
}
