﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ryujin
{
    /// <summary>
    /// 弾の当たり判定情報を表すクラスです。
    /// </summary>
    class BulletInfo
    {
        /// <summary>
        /// X方向サイズ。
        /// </summary>
        public int size_x;

        /// <summary>
        /// Y方向サイズ。
        /// </summary>
        public int size_y;

        /// <summary>
        /// 色の種類数。
        /// </summary>
        public int col_num;

        /// <summary>
        /// 当たり判定範囲。
        /// </summary>
        public double range;
        
        /// <summary>
        /// コンストラクタ。
        /// </summary>
        /// <param name="size_x">X方向サイズ</param>
        /// <param name="size_y">Y方向サイズ</param>
        /// <param name="col_num">色の種類数</param>
        /// <param name="range">当たり判定範囲</param>
        public BulletInfo(int size_x, int size_y, int col_num, double range)
        {
            this.size_x = size_x;
            this.size_y = size_y;
            this.col_num = col_num;
            this.range = range;
        }
    }
}
