﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ryujin
{
    /// <summary>
    /// 敵の出現情報を表すクラスです。
    /// </summary>
    class EnemyOrder
    {
        /// <summary>
        /// カウンタ。
        /// </summary>
        public int cnt;

        /// <summary>
        /// パターン。
        /// </summary>
        public int pattern;

        /// <summary>
        /// 敵の種類。
        /// </summary>
        public int knd;

        /// <summary>
        /// 初期 X座標。
        /// </summary>
        public double x;

        /// <summary>
        /// 初期 Y座標。
        /// </summary>
        public double y;

        /// <summary>
        /// 移動スピード。
        /// </summary>
        public double sp;

        /// <summary>
        /// 弾幕開始時間。
        /// </summary>
        public int bltime;

        /// <summary>
        /// 弾幕の種類。
        /// </summary>
        public int blknd;

        /// <summary>
        /// 色。
        /// </summary>
        public int col;

        /// <summary>
        /// 体力。
        /// </summary>
        public int hp;

        /// <summary>
        /// 弾の種類。
        /// </summary>
        public int blknd2;

        /// <summary>
        /// 停滞時間。
        /// </summary>
        public int wait;
        
        /// <summary>
        /// アイテム(6種類)。
        /// </summary>
        public int[] item_n = new int[6];
        
        /// <summary>
        /// 初期化します。
        /// </summary>
        public void initialize()
        {
            this.cnt = 0;
            this.pattern = 0;
            this.knd = 0;
            this.x = 0.0;
            this.y = 0.0;
            this.sp = 0.0;
            this.bltime = 0;
            this.blknd = 0;
            this.col = 0;
            this.hp = 0;
            this.blknd2 = 0;
            this.wait = 0;
            for (int i = 0; i < item_n.Length; i++)
                this.item_n[i] = 0;
        }
    }
}
