﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ryujin
{
    /// <summary>
    /// ベクトルを表すクラスです。
    /// </summary>
    class Vector2
    {
        /// <summary>
        /// X方向。
        /// </summary>
        public double x;
        
        /// <summary>
        /// Y方向。
        /// </summary>
        public double y;

        /// <summary>
        /// ベクトルの差を設定します。
        /// </summary>
        /// <param name="p">ベクトル 1</param>
        /// <param name="q">ベクトル 2</param>
        public void Vector2Diff(Vector2 p, Vector2 q)
        {
            this.x = p.x - q.x;
            this.y = p.y - q.y;
        }

        /// <summary>
        /// ベクトル pと qの内積を計算します。
        /// </summary>
        /// <param name="p">ベクトル 1</param>
        /// <param name="q">ベクトル 2</param>
        /// <returns>内積</returns>
        public static double Vector2InnerProduct(Vector2 p, Vector2 q)
        {
            return p.x * q.x + p.y * q.y;
        }

        /// <summary>
        /// ベクトル pと qの外積を計算します。
        /// </summary>
        /// <param name="p">ベクトル 1</param>
        /// <param name="q">ベクトル 2</param>
        /// <returns>外積</returns>
        public static double Vector2OuterProduct(Vector2 p, Vector2 q)
        {
            return p.x * q.y - p.y * q.x;
        }
    }
}
