﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DxLibDLL;

namespace Ryujin
{
    /// <summary>
    /// ステージタイトルを表すクラスです。
    /// </summary>
    class StageTitle
    {
        /// <summary>
        /// フラグ。
        /// </summary>
        public int flag;

        /// <summary>
        /// 画像ハンドル。
        /// </summary>
        public int img;

        /// <summary>
        /// カウンタ。
        /// </summary>
        public int cnt;

        /// <summary>
        /// 輝度。
        /// </summary>
        public int brt;

        /// <summary>
        /// 出現カウント。
        /// </summary>
        public int appear_cnt;

        /// <summary>
        /// 初期化します。
        /// </summary>
        public void initialize()
        {
            this.flag = 0;
            this.img = 0;
            this.cnt = 0;
            this.brt = 0;
            this.appear_cnt = 0;
        }

        /// <summary>
        /// ゲームの初期化をします。
        /// </summary>
        public void ini()
        {
            this.appear_cnt = GV.stage_title_counts[GV.stage];
        }

        /// <summary>
        /// ステージタイトル表示の計算をします。
        /// </summary>
        public void calc_stage_title()
        {
            if(this.appear_cnt == GV.stage_count) //今 が表示開始時なら
            {
                this.flag = 1;
                this.img = DX.LoadGraph(Setting.BASE_DIR + "img/board/subject0.png");
            }

            if(this.flag == 0)
                return;

            if(this.cnt < 128) // 最初の 128の間段々明るく
                this.brt += 2;
            if(this.cnt > 128+128) // 段々暗く
                this.brt -= 2;
            if(this.cnt > 128 + 128 + 128) // 終わり
            {
                this.cnt = 0;
                this.brt = 0;
                this.flag = 0;
                DX.DeleteGraph(this.img); // 画像解放
                return;
            }

            this.cnt ++;

            // 強制終了した時の画像解放処理が必要
        }
    }
}
